# Bash Keybindings

## Navigation

| Keybinding                            | Action                                  | Shell     |
|---------------------------------------|-----------------------------------------|-----------|
| <kbd>Ctrl</kbd> + <kbd>a</kbd>        | Go to the beginning of the line         | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>e</kbd>        | Go to the end of the line               | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>f</kbd>        | Move one character forward              | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>b</kbd>        | Move one character backward             | bash, zsh |
| <kbd>Alt</kbd> + <kbd>f</kbd>         | Move one word forward                   | bash, zsh |
| <kbd>Alt</kbd> + <kbd>b</kbd>         | Move one word backward                  | bash, zsh |
| <kbd>Alt</kbd> + <kbd>b</kbd>         | Jump and mark to the beginning and back | bash, zsh |

## Line Editing

| Keybinding                            | Action                                         | Shell     |
|---------------------------------------|------------------------------------------------|-----------|
| <kbd>Ctrl</kbd> + <kbd>d</kbd>        | Delete forward                                 | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>h</kbd>        | Delete backward                                | bash, zsh |
| <kbd>Alt</kbd> + <kbd>d</kbd>         | Delete word forward                            | bash, zsh |
| <kbd>Alt</kbd> + <kbd>w</kbd>         | Delete word backward                           | bash, zsh |
| <kbd>Alt</kbd> + <kbd>Backspace</kbd> | Delete word backward                           | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>k</kbd>        | Delete everything to the end of the line       | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>u</kbd>        | Delete everything to the beginning of the line | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>y</kbd>        | Yank (paste) last deleted item                 | bash, zsh |
| <kbd>Alt</kbd> + <kbd>p</kbd>         | Replace arg with previous command's arg        | zsh       |
| <kbd>Alt</kbd> + <kbd>n</kbd>         | Replace arg with next command's arg            | zsh       |
| <kbd>Alt</kbd> + <kbd>.</kbd>         | Yank (paste) the last command's arg            | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>?</kbd>        | Undo                                           | bash, zsh |

## Signals and Symbols

| Keybinding                     | Action                                   | Shell     |
|--------------------------------|------------------------------------------|-----------|
| <kbd>Ctrl</kbd> + <kbd>c</kbd> | Send SIGINT                              | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>\</kbd> | Send SIGQUIT                             | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>z</kbd> | Send XOFF/SIGTSTP                        | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>c</kbd> | Send XON/SIGCONT                         | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>l</kbd> | Clear the screen (similar to `clear`)    | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>d</kbd> | Send EOF (can be used to exit the shell) | bash, zsh |

## History

| Keybinding                     | Action                     | Shell     |
|--------------------------------|----------------------------|-----------|
| <kbd>Ctrl</kbd> + <kbd>p</kbd> | Previous command           | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>n</kbd> | Next command               | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>r</kbd> | Reverse search the history | bash, zsh |
| <kbd>Ctrl</kbd> + <kbd>s</kbd> | Search the history         | bash, zsh |
